theory "ethz-04Datatype"
imports "../ethz-01/ethz-01"
begin


constdefs

 D1a :: "(networks, DummyContent) Policy"
"D1a \<equiv> allow_prots_from_to {IP,icmp} eth_intern any"

 D1b :: "(networks, DummyContent) Policy"
"D1b \<equiv> allow_prots_from_to {IP,icmp} eth_private any"

 D3 :: "(networks, DummyContent) Policy"
"D3 \<equiv> allow_prots_from_to {IP,icmp} any any"


constdefs
 DefaultPolicy :: "(networks,DummyContent) Policy"
"DefaultPolicy \<equiv> D3 ++ D1b ++ D1a"

lemmas PolicyLemmas = PolicyLemmas DefaultPolicy_def D1a_def D1b_def D1c_def D3_def


test_spec "not_in_same_net x \<longrightarrow> FUT x =  (deny_all ++ DefaultPolicy) x"
apply (prepareFWthm)
apply (simp add: PolicyLemmas stateless_rules)
apply (gen_test_cases "FUT")
apply (simp_all add: not_in_same_net_def PolicyLemmas) 
store_test_thm "DP"


gen_test_data "DP"
thm DP.test_data


test_spec "not_in_same_net x \<longrightarrow> FUT x =  (deny_all ++ DefaultGlobalPolicy ++ DefaultPolicy ++ MandatoryGlobalPolicy) x"
apply (prepareFWthm)
apply (simp add: PolicyLemmas stateless_rules)
apply (gen_test_cases "FUT")
apply (simp_all add: not_in_same_net_def PolicyLemmas) 
store_test_thm "all"


gen_test_data "all"
thm all.test_data


end