theory eight
imports IntegerPairNetwork PortCombinators  "../../src/FWTesting" 
begin

constdefs
  dmz::"IntegerPair subnet"
   "dmz \<equiv> {{(a,b) . (a<10) }}"

 internet :: "IntegerPair subnet"
  "internet \<equiv> {{(a,b).  (a > 10)}}"


constdefs
 not_in_same_net :: "(IntegerPair,DummyContent) packet \<Rightarrow> bool"
 "not_in_same_net x  \<equiv>  (src x \<sqsubset> dmz \<longrightarrow> ( \<not> (dest x \<sqsubset> dmz))) \<and> 
                        (src x \<sqsubset> internet \<longrightarrow>  \<not> dest x \<sqsubset> internet)"
                     

constdefs

 w1::"IntegerPair subnet"
 "w1 \<equiv> {{(a,b) . (a=1) }}"
                     
 w2::"IntegerPair subnet"
 "w2 \<equiv> {{(a,b) . (a=2) }}"

 w3::"IntegerPair subnet"
 "w3 \<equiv> {{(a,b) . (a=3) }}"

 w4::"IntegerPair subnet"
 "w4 \<equiv> {{(a,b) . (a=4) }}"                     

 w5::"IntegerPair subnet"
 "w5 \<equiv> {{(a,b) . (a=5) }}"
                  

 w6::"IntegerPair subnet"
 "w6 \<equiv> {{(a,b) . (a=6) }}"

 w7::"IntegerPair subnet"
 "w7 \<equiv> {{(a,b) . (a=7) }}"
                  

 w8::"IntegerPair subnet"
 "w8 \<equiv> {{(a,b) . (a=8) }}"

 w9::"IntegerPair subnet"
 "w9 \<equiv> {{(a,b) . (a=9) }}"


                     


constdefs 
  policy :: "(IntegerPair, DummyContent) Policy"
 "policy \<equiv> deny_all ++ 
   allow_prot_from_to http w1 internet ++ 
   allow_prot_from_to ftp w2 internet ++ 
   allow_prot_from_to https w3 internet ++ 
   allow_prot_from_to imap w4 internet ++ 
   allow_prot_from_to imaps w5 internet ++ 
   allow_prot_from_to smtp w6 internet ++ 
   allow_prot_from_to udp w7 internet ++ 
   allow_prot_from_to IP w8 internet " 

(*icmp unknown*)


lemmas PolicyLemmas = w1_def w2_def w3_def w4_def w5_def w6_def w7_def w8_def w9_def policy_def internet_def dmz_def
  


test_spec "not_in_same_net x \<longrightarrow> FUT (x:: (IntegerPair,DummyContent) packet) = policy x"
apply (prepareFWthm)
apply (simp add: PolicyLemmas IntegerNetworkLemmas PortCombinators stateless_rules not_in_same_net_def)
apply (gen_test_cases "FUT")
apply (simp_all add: PolicyLemmas IntegerNetworkLemmas not_in_same_net_def)
store_test_thm "test"

testgen_params[iterations=100]

gen_test_data "test"

thm test.test_data

end
