theory five
 imports  PolicyCombinators "../../src/FWTesting" 
begin


datatype Networks = Workstation | Internet

instance Networks::net .. 

constdefs
  workstation::"Networks subnet"
  "workstation \<equiv> {{Workstation}}"
  internet :: "Networks subnet"
  "internet \<equiv> {{Internet}}"


constdefs
 not_in_same_net :: "(Networks,DummyContent) packet \<Rightarrow> bool"
 "not_in_same_net x  \<equiv>  (src x \<sqsubset> workstation \<longrightarrow> ( (dest x \<sqsubset> internet))) \<and> 
                        (src x \<sqsubset> internet \<longrightarrow>  dest x \<sqsubset> workstation)"
                     
(* 2 rules *)



constdefs
policy :: "(Networks, DummyContent) Policy"
 "policy \<equiv> deny_all ++ allow_prot_from_to http workstation internet
++ allow_prot_from_to ftp workstation internet++ allow_prot_from_to imap workstation internet++ allow_prot_from_to udp workstation internet "
   
lemmas PolicyLemmas =  policy_def workstation_def internet_def src_def dest_def in_subnet_def protocol_def
  


test_spec "not_in_same_net x \<longrightarrow> FUT x = policy x"
apply (prepareFWthm)
apply (simp add: PolicyLemmas stateless_rules)
apply (gen_test_cases "FUT")
apply (simp_all add: PolicyLemmas  not_in_same_net_def)

store_test_thm "test"


gen_test_data "test"

thm test.test_data






end