theory eight
imports IntegerPairNetwork PortCombinators "../../src/FWTesting" 
begin


constdefs
  workstation::"IntegerPair subnet"
   "workstation \<equiv> {{(a,b) . (a=3) }}"

 internet :: "IntegerPair subnet"
  "internet \<equiv> {{(a,b).  \<not> (a =3)}}"


constdefs
 not_in_same_net :: "(IntegerPair,DummyContent) packet \<Rightarrow> bool"
 "not_in_same_net x  \<equiv>  (src x \<sqsubset> workstation \<longrightarrow> ( (dest x \<sqsubset> internet))) \<and> 
                        (src x \<sqsubset> internet \<longrightarrow>  dest x \<sqsubset> workstation)"
                     
(* 2 rules *)



constdefs
policy :: "(IntegerPair, DummyContent) Policy"
 "policy \<equiv> deny_all ++ allow_prot_from_to http workstation internet
++ allow_prot_from_to ftp workstation internet++ allow_prot_from_to imap workstation internet++ allow_prot_from_to udp workstation internet ++ allow_prot_from_to IP workstation internet++ allow_prot_from_to icmp workstation internet ++ allow_prot_from_to https workstation internet  "
                  
constdefs
policyS :: "(IntegerPair, DummyContent) Policy"
 "policyS \<equiv> deny_all ++ allow_prots_from_to {http,  ftp,  imap,  udp,  IP,  icmp,  https} workstation internet  "

lemma "policy = policyS"
apply (rule ext)
apply (simp add: policy_def workstation_def internet_def policyS_def IntegerNetworkLemmas PortCombinators stateless_rules)
done
                  

lemmas PolicyLemmas =  policy_def workstation_def internet_def

  


test_spec "not_in_same_net x \<longrightarrow> FUT (x:: (IntegerPair,DummyContent) packet) = policy x"
apply (prepareFWthm)
apply (simp add: policyS_def PolicyLemmas IntegerNetworkLemmas PortCombinators stateless_rules)
apply (gen_test_cases "FUT")
apply (simp_all add: PolicyLemmas IntegerNetworkLemmas not_in_same_net_def)

store_test_thm "test"


gen_test_data "test"

thm test.test_data




end