(*****************************************************************************
 * HOL-TestGen --- theorem-prover based test case generation
 *                 http://www.brucker.ch/projects/hol-testgen/
 *                                                                            
 * FWTesting.thy --- 
 * This file is part of HOL-TestGen.
 *
 * Copyright (c) 2008 ETH Zurich, Switzerland
 *               2008 Achim D. Brucker, Germany 
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of the copyright holders nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************)
(* $Id: FWTesting.thy 7551 2008-03-27 21:58:15Z brucker $ *)

theory 
  FWTesting
imports 
  Testing
  PacketFilter
  StatefulFW
begin


(* We should define the following tactics:
 - prepare_fw_spec
 - simplify_policy

  - fw_gen_test_cases simp=yes|no ss_set = 

*)


 






ML {*
fun prepare_test_thm_tac thy  =
                 ((res_inst_tac [("x","x")] spec 1) THEN
                  (resolve_tac [allI] 1) THEN
                  (split_all_tac 1) THEN
                  (TRY (resolve_tac [impI] 1)) );
*}

method_setup prepareFWthm =
  {*
  Method.no_args (Method.SIMPLE_METHOD' (prepare_test_thm_tac)) 
  *} "Prepares the Firewall testing theorem"


ML {*


fun simplify_policy_tac thy  =
           (REPEAT ((stac map_assoc  1) THEN
                   (asm_full_simp_tac (simpset() addsimps PSss) 1)));

*}



method_setup simplifyPolicy =
  {* 
  Method.no_args (Method.METHOD (simplify_policy_tac))
  *} "Optimize Policy"


end


