theory PolicyPortSimplification
imports PolicySimplification PortCombinators
begin


text{* Those Policy Simplification Lemmas which only work for network representations with Ports *}

lemma pp1c: "deny_all ++ deny_prot_from_port_to A B C D = deny_all"
apply (rule ext)
apply (simp add: deny_prot_from_port_to_def)
apply (simp add: stateless_rules)
done


lemma pp1d: "deny_all ++ deny_prot_from_to_port A B C D = deny_all"
apply (rule ext)
apply (simp add: deny_prot_from_to_port_def)
apply (simp add: stateless_rules)
done


lemma pp1g: "allow_all ++ allow_prot_from_port_to A B C D = allow_all"
apply (rule ext)
apply (simp add: allow_prot_from_port_to_def)
apply (simp add: stateless_rules)
done


lemma pp1h: "allow_all ++ allow_prot_from_to_port A B C D = allow_all"
apply (rule ext)
apply (simp add: allow_prot_from_to_port_def)
apply (simp add: stateless_rules)
done


lemma pp2b1: "allow_prot_from_to_port p A B P ++ allow_prot_from_to_port q A B Q = allow_prots_from_to_port {(p,P),(q,Q)} A B"
apply (rule ext)
apply (simp add: PortCombinators stateless_rules src_def protocol_def in_subnet_def)
done


lemma pp2b2: "allow_prots_from_to_port P A B ++ allow_prot_from_to_port q A B port = allow_prots_from_to_port (insert (q,port) P) A B"
apply (rule ext)
apply (simp add: stateless_rules PortCombinators src_def protocol_def  dest_def in_subnet_def)
apply auto
done

lemma pp2b3: "allow_prot_from_to_port q A B port ++ allow_prots_from_to_port P A B = allow_prots_from_to_port (insert (q,port) P) A B"
apply (rule ext)
apply (simp add: stateless_rules PortCombinators src_def protocol_def  dest_def in_subnet_def)
apply auto
done


(* Fuer allow_prots_from_port_to *)
lemma pp2c1: "allow_prot_from_port_to p AA P BB ++ allow_prot_from_port_to q AA Q BB  = allow_prots_from_port_to {(p,P),(q,Q)} AA BB"
apply (rule ext)
apply (simp add: stateless_rules PortCombinators src_def protocol_def dest_def in_subnet_def)
done


lemma pp2c2: "allow_prots_from_port_to P A B ++ allow_prot_from_port_to q A port B  = allow_prots_from_port_to (insert (q,port) P) A B"
apply (rule ext)
apply (simp add: stateless_rules PortCombinators src_def protocol_def dest_def in_subnet_def)
apply auto
done


lemma pp2c3: "allow_prot_from_port_to q A port B ++  allow_prots_from_port_to P A B  = allow_prots_from_port_to (insert (q,port) P) A B"
apply (rule ext)
apply (simp add: stateless_rules PortCombinators src_def protocol_def dest_def in_subnet_def)
apply auto
done


lemmas PSss =  PSss pp1c pp1d pp1g pp1h pp2b1 pp2b2 pp2b3 pp2c1 pp2c2 pp2c3


ML {*
val map_assoc = @{thm map_assoc}
val PSss = @{thms PSss}
*}





end
